# $Id: ModDrink.pm,v 1.8 2006-03-27 20:35:18 bobzilla Exp $
# Copyright (c) 2003-2004 Robert Hagemann <bobzilla@gothictech.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

package ModDrink;

@ModDrink::ISA = qw(OmniMod);

use strict;

use URI::Escape;

my $on = 1;

sub name() {
  my $this = shift;
  return "Drink!";
}

sub handleMessage {
  my $this = shift;
  my $irc = shift;
  my $channel = shift;
  my $nick = shift;
  my $message = shift;

  return if ! $on;
  return if ! &applicable( $nick, $message );

  if ( rand > 0.50 ) {
    $irc->privmsg( $channel, "DRINK!" );
  }
}

sub applicable {
  my $nick = shift;
  my $message = shift;
  
  if ( $message =~ /mcsweeneys\.net/ and $nick =~ /^bopo/i ) {
    return 1;
  }
  if ( ($message =~ /^cme\s+/si || $message =~ /\s+cme$/si
        || $message =~ /\s+cme\s+/si ) 
      and $nick =~ /^(bauersc|notpaul)/i ) {
    return 1;
  }
  
  return 0;
}

1;
