# $Id: ModTwit.pm,v 1.6 2009/12/08 20:18:13 uhtu Exp $
# Copyright (c) 2009 Hugh Kennedy <kennedyh@umich.edu>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

package ModTwit;

@ModTwit::ISA = qw(OmniMod);

use strict;

use URI::Escape;
use LWP::UserAgent;

my $on = 1;
my $ua = LWP::UserAgent->new;
$ua->agent('Mozilla/5.0 (Windows; U; Windows NT 5.0; en-US; rv:0.9.2) Gecko/20010726 Netscape6/6.1');
$ua->timeout(5); # 5s timeout

sub help {
  if ( defined wantarray ) { # do we have help?
      return 1;
  }

  my $this = shift;
  my $irc = shift;
  my $nick = shift;
  my $message = shift;

  $irc->notice( $nick, "[twit username]  -> see \@username's banal blathering" );
}

sub name() {
  my $this = shift;
  return "twit";
}



sub handleMessage {
  my $this = shift;
  my $irc = shift;
  my $channel = shift;
  my $nick = shift;
  my $message = shift;

  return if ! $on;
  return if ! &applicable( $message );
  if ( $message =~ /^tw[ia]t\s+@?([\w\d]+)$/ ) {
    $irc->privmsg( $channel, &get_twit( $1 ) );
  }
}

sub handlePrivateMessage {
  my $this = shift;
  my $irc = shift;
  my $nick = shift;
  my $message = shift;

  return if ! $on;
  return if ! &applicable( $message );

  if ( $message =~ /^tw[ia]t\s+@?([\w\d]+)$/ ) {
    $irc->notice( $nick, &get_twit( $1 ) );
  }
}

sub applicable {
  my $message = shift;
  if ( $message =~ /^tw[ia]t\s+@?([\w\d]+)$/ ) {
    return 1;
  } 
  return 0;
}

sub get_twit {
  my ($twat) = @_;

	my $url = "http://mobile.twitter.com/$twat";
  my $request = HTTP::Request->new(GET => $url);
  my $response = $ua->request($request);
  my $html = $response->as_string();
   # warn $html;	
	my $retval = "(xOO>\\"; # thanks, evilai!
        if ( $html =~ m@<td class="timestamp">\s*<a[^>]+>(.*?)</a>.*?<div class="tweet-text">(.*?)</div>@si ) {
		my $twit = $2;
		my $when = $1;
                while ($twit =~ s@<a .+?>(.+?)</a>@$1@g){
                }
                $twit =~ s|<s>(.*?)</s>|$1|gi;
		$retval = "\@$twat: '$twit' ($when)";
	}

	return $retval;
}


1;
