# $Id: OmniHash.pm,v 1.3 2004-05-16 23:27:26 uhtu Exp $
# Copyright (c) 2002-2004 Robert Hagemann <bobzilla@gothictech.com>
#
# Permission to use, copy, modify, and distribute this software for any
# purpose with or without fee is hereby granted, provided that the above
# copyright notice and this permission notice appear in all copies.
#
# THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
# WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
# MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
# ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
# WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
# ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
# OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

package OmniHash;

my %DATA;

sub getHash {
	my $name = shift;

	if ( ! defined $DATA{ $name } ) {
		my %chandata;
		dbmopen( %chandata, $name, 0644 );
		$DATA{ $name } = \%chandata;
	}

	return $DATA{ $name };
}

sub closeAllHashes {
	foreach my $name ( keys %DATA ) {
		closeHash( $name );
	}
}

sub closeHash {
	my $name = shift;
	my $hash = $DATA{ $name };
	dbmclose( %{$hash} );
	delete $DATA{ $name };
}

1;
